config/routes.rb
Rails.application.routes.draw do
  root 'static_pages#home'
  get    'stats'            => 'static_pages#stats'
  get    'about'           => 'static_pages#about'
  get    'contact'         => 'static_pages#contact'
  get    'login'           => 'sessions#new'
  post   'login'           => 'sessions#create'
  delete 'logout'          => 'sessions#destroy'
  resources :schools, :except => [:index]
  get       'schools'          => 'schools#show', :defaults => { :id => "1" }
  resources :students
  get       'students_signup'  => 'students#new'
  get       'students_load_suggestions' => 'students#load_suggestions'
  get       'students_redirect' => 'students#redirect'
  resources :companies
  get       'companies_signup' => 'companies#new'
  resources :skills
  resources :account_activations, only: [:edit]
  resources :password_resets,     only: [:new, :create, :edit, :update]
  resources :matches
  resources :stages

end

app/models/stage.rb
class Stage < ActiveRecord::Base
  belongs_to :student
  belongs_to :company
  validates_presence_of :student
  validates_presence_of :company
  validate :end_time_is_greater_than_start_time
  validates :student_id, uniqueness: { scope: :company_id }

  validates :start_time, presence: true
  validates :end_time,   presence: true

  private

    def end_time_is_greater_than_start_time
      if end_time < start_time
        errors.add(:start_time, "non può essere maggiore della data di fine")
      end
    end

end

app/controllers/stages_controller.rb
class StagesController < ApplicationController

  before_action :logged_in_user, only: [:new, :create, :index, :edit,
                                        :update, :destroy]

  def new
    @stage = Stage.new
    match = Match.find(params[:id])
    @stage.student_id = match.student_id
    @stage.company_id = match.company_id
    student = Student.find(@stage.student_id)
    redirect_to root_url if current_user != student
    @match = { student: student.name,
               company: Company.find(@stage.company_id).name}
  end

  def create
    # beofre filter sull'user
    @stage = Stage.new(stage_params)
    if @stage.save
      flash[:info] = "Richiesta di inizio stage inviata"
      redirect_to root_url
    else
      flash[:danger] = "Errore nella richiesta"
      redirect_to root_url
    end
  end

  def index
    redirect_to root_url unless current_user.is_a? Company
    @stages = Stage.where(company_id: current_user.id, activated: false)
    @accepted_stages = Stage.where(company_id: current_user.id, activated: true)
  end

  def show
    @stage = Stage.find(params[:id])
    @company = Company.find(@stage.company_id)
    redirect_to root_url unless current_user == Student.find(@stage.student_id)
  end

  def update
    @stage = Stage.find(params[:id])
    company = Company.find(@stage.company_id)
    if company.update(vacancies: company.vacancies - 1) &&
        @stage.update(activated: true)
      flash[:success] = "Stage accettato"
      redirect_to stages_path
    else
      if company.vacancies < 0
        flash[:warning] = "Non hai più posti disponibili, non puoi più accettare stage."
      end
      redirect_to stages_path
    end
  end

  def destroy
    stage = Stage.find(params[:id])
    stage.destroy
    if current_user.is_a? Student
      flash[:success] = "Richiesta annullata"
      redirect_to matches_path
    else
      flash[:success] = "Studente rifiutato"
      redirect_to stages_path
    end
  end

  private

    def stage_params
      params.require(:stage).permit(:student_id, :company_id, :start_time,
                                    :end_time, :activated)
    end

    # Before filters

    # Confirms a logged-in user.
    def logged_in_user
      unless logged_in?
        store_location
        flash[:danger] = "Devi essere loggato per eseguire quest'azione."
        redirect_to login_url
      end
    end

end

app/helpers/stages_helper.rb
module StagesHelper

end

app/views/stages/_stage.html.erb
<li>
  <div class="v-align">
    <div style="flex:3">
      <%= gravatar_for Student.find(stage.student_id), size: 50 %>
      <div style="margin-left:10px;display:inline-block"></div>
      <%= link_to Student.find(stage.student_id).name, student_path(stage.student_id) %>
    </div>

    <div style="flex:1;text-align:center">
      <%= stage.start_time %>
    </div>

    <div style="flex:1;text-align:center">
      <%= stage.end_time %>
    </div>
    <% unless stage.activated? %>
      <div class="v-align" style="width:150px;margin-left:10px">
        <%= link_to "Rifiuta", stage, method: :delete,
                                      data: { confirm: "Sei sicuro?" },
                                      class: "btn btn-danger" %>
        <%= link_to "Accetta", stage_path(stage.id),
                               :method => :put,
                               class: "btn btn-success",
                               style: "margin-left:5px" %>
      </div>
    <% end %>
  </div>
</li>

app/views/stages/index.html.erb
<% if current_user.is_a? Company %>
  <h3>Richieste di stage in attesa</h3>
  <% if @stages.length > 0 %>
      <ul class="users" style="padding:0">
        <li>
          <div style="display:flex">
            <div style="flex:3">
              <b>Nome studente</b>
            </div>
            <div style="flex:1;text-align:center">
              <b>Data di inizio</b>
            </div>
            <div style="flex:1;text-align:center">
              <b>Data di fine</b>
            </div>
            <div style="width:160px">

            </div>
        </li>
        <%= render @stages %>
      </ul>
  <% else %>
    Nessuna richiesta di stage in attesa
  <% end %>
    <br>
    <br>
    <h3>Stage accettati</h3>
  <% if @accepted_stages.length > 0 %>
      <ul class="users" style="padding:0">
        <li>
          <div style="display:flex">
            <div style="flex:3">
              <b>Nome studente</b>
            </div>
            <div style="flex:1;text-align:center">
              <b>Data di inizio</b>
            </div>
            <div style="flex:1;text-align:center">
              <b>Data di fine</b>
            </div>
        </li>
        <%= render @accepted_stages %>
      </ul>
  <% else %>
    Nessuno stage è ancora stato accettato
  <% end%>
<% end %>

app/views/stages/new.html.erb
<% provide(:title, 'Richiedi stage') %>
<h1>Richiedi stage</h1>
<div class="row">
  <div class="col-md-6 col-md-offset-3">
    <%= form_for(@stage) do |f| %>
      <%= render "shared/error_messages", object: f.object %>

      <%= f.label :student_id, "Studente" %>
      <%= text_field_tag :student_name, @match[:student],
                         class: "form-control", :readonly => true %>
      <%= f.hidden_field :student_id, class: "form-control" %>

      <%= f.label :company_id, "Azienda" %>
      <%= text_field_tag :company_name, @match[:company],
                         class: "form-control", :readonly => true %>
      <%= f.hidden_field :company_id, class: "form-control" %>

      <%= f.label :start_time, "Data inizio" %>
      <%= f.text_field :start_time, class: "form-control" %>

      <%= f.label :end_time, "Data fine" %>
      <%= f.text_field :end_time, class: "form-control" %>

      <%= f.submit "Richiedi stage", class: "btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/stages/show.html.erb
<% provide(:title, "Stage") %>

<h1>Il tuo stage</h1>
<% if !@stage.activated? && (current_user.is_a? Student) %>
  Lo stage non è ancora stato accettato dall'aziienda. Riprova più tardi.
<% else %>
  <h3>Azienda</h3>
  <%= link_to @company.name, company_path(@company.id) %>
  <h3>Data di inizio</h3>
  <%= @stage.start_time %>
  <h3>Data di fine</h3>
  <%= @stage.end_time %>
<% end %>